import time
import threading
import tempfile

import subprocess
import os
import signal
import datetime
import shutil
#import pexpect

from wsmanager import WSManager
## Crea un swmanager unic, al que li enviaran tots els missatges, etiquetats per l'id del treball


#import signal
#import shutil


class Task:
    def __init__(self, taskid, command):
        '''
        It is a task in server, with certain taskid and performing certain command
        When is created, its status will be "PREPARED"
        And waits to be run
        It prepares command and log file in /run
        '''
        
        self.taskid=taskid
        self.process=None
        self.status='PREPARED'
        self.command=command
        self.logfolder="/run/taskmanager"
        self.filepipe=''
        self.locks = {}
        self.seek=0
        
        # Clean log folder and create
        if (os.path.exists(self.logfolder)):
            shutil.rmtree(self.logfolder)
        os.mkdir(self.logfolder)
    
        '''
        'msg':None,
        'target': target,
        'command':command,
        started_by':str(ip),
        listeners': [],
        filepipe': '',
        seek' : 0,
        method':call_info['method'],
        class': call_info['class']
        '''

        pass

    def get(self):
        '''
        Returns this task
        '''
        
        return str({"taskid":self.taskid,
                "process":self.process,
                "status":self.status,
                "command": self.command,
                "logfolder":self.logfolder,
                "filepipe": self.filepipe});
        
    def getFilePipe(self):
        '''
        Returns this task filepipe
        '''
        return self.filepipe

    def getStatus(self):
        '''
        Returns this task status
        '''
        return self.status

    def run(self):
        '''
        Runs current task
        
        it prepares process and temporally log file and runs it
        
        '''
        # locking thread
        lock = threading.Lock()
        self.locks[self.taskid]={}
        self.locks[self.taskid]['lock'] = lock        
        self.locks[self.taskid]['lock'].acquire()
        
        # Create temp logfile
        temp = tempfile.NamedTemporaryFile(prefix='pipe_', dir=self.logfolder, delete=False)
        proc = subprocess.Popen([self.command+"; sleep 5"],  shell=True, stdout=temp, preexec_fn=os.setsid)
        #proc=pexpect.spawn(self.command, logfile=temp)  #

        # Adding process
        self.process=proc;
        self.status="RUNNING"
        self.filepipe=temp.name
        
        
        # Getting process output
        ret=self.process.poll()
        print str(ret)
        while ret is None:
            #time.sleep(3)
            ret=self.process.poll()
            
        #print str(ret)
        

        '''
        # getting proces output with expect
        while True:
            ret=0;
            try:
                proc.expect("\n")
                stdout=proc.before
            except pexpect.EOF:
                proc.close()
                ret=proc.exitstatus
                print "FIN"
            break
        '''
                
        
        if (str(ret)=='0'):
            self.status="DONE"
        elif (str(ret)=='-9'):			
            self.status="CANCELLED"
        else: # return code 1 when install fails
            self.status="BROKEN"


        print "[TASKMANAGER] END WAIT AT "+str(datetime.datetime.now())
        print "[TASKMANAGER] FINISHING!!!, return code: "+str(ret)
        
        ## Millora: Abans d'enviar que ha acabat que espere a tindre els buffers buits...
        
        
        # Sending last line to log for all listeners
        line="<b>Finished with status:"+self.status+"</b>\n"
        aux = open(self.filepipe,'a')
        aux.writelines(line)
        aux.close()


        # Append result of job and release mutex. Now all inform_me return finish
        self.locks[self.taskid]['result'] = str(ret)
        self.locks[self.taskid]['lock'].release()
                
        pass
        
    def runTask(self):
        '''
        runs task in an independent thread
        '''
        # Prepare thread        
        taskthread=threading.Thread(target=self.run, args=())
        taskthread.daemon = True
        taskthread.start()
        
        return True
        
        ### Exec command ###
        
        
        # Prepare file pipe
        #temp = tempfile.NamedTemporaryFile(prefix='pipe_', dir=self.logfolder, delete=False)
        
        # New exec command, ignoring stderr stdin for now
        #proc = subprocess.Popen([self.command],  shell=True, stdout=temp, preexec_fn=os.setsid)
        
        #self.process=proc
        #self.status="RUNNING"
        #self.filepipe=temp.name #????
        
    
        '''
            
        
        except Exception as e:
            job['status']="Error"
            print '[LmdServer]',e
            if (ret is None):
                job['msg']="Err code None (running)"
            elif (ret<0):
                job['msg']="Interrupted by signal: "+str(ret)
            else:
                job['msg']="Aparently all went well: "+str(ret)
            
    
            # Append result of job and release mutex. Now all inform_me return finish
            self.locks[job['taskid']]['result'] = str(ret)
            self.locks[job['taskid']]['lock'].release()
    
            return str(e)
        
        '''    

        
        pass

    def stop(self):
        try:
            #print "Killing me softly"
            #msg=self.process.killpg();
            msg=os.killpg(self.process.pid, signal.SIGTERM)
            
            #print "Killing me with this song: ",msg
            return {"status": True, "msg": str(msg)}
        except Exception as e:
            #print "with this song: ", str(e)
            return {"status": False, "msg": str(e)}
    
    
    